"use strict";
this.name				= "CollapsShields";
this.author				= "Stranger";
this.copyright			= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description		= "Script simulates collapsing shields and fuel consumption";
this.version			= "2.6";

this.startUp = function()
    {
    this.self = player.ship;
    }

this.shipWillLaunchFromStation = this.startFuelTimer = function()
	{
	this.$fuelFlag = 0;
    this.$fuelCounter = 0;
    this.$energyCounter = this.self.maxEnergy;
	if(this.$fuelWatchTimer)
		{ this.$fuelWatchTimer.start(); }
	else
		{ this.$fuelWatchTimer = new Timer(this, this.$checkFuel,0,1); }
	}

this.shipWillDockWithStation = this.shipDied = this.stopFuelTimer = function()
	{
	this.$fuelFlag = 0;
    this.$fuelCounter = 0;
    this.$energyCounter = this.self.maxEnergy;    
	if(this.$fuelWatchTimer && this.$fuelWatchTimer.isRunning) { this.$fuelWatchTimer.stop(); } 
	}
	
this.$checkFuel = function()
	{	

	if(this.self.speed > 0)       // basic fuel consumption
		{                           //  increment flag, looping between 0 and 60
		this.$fuelFlag += 1;
		this.$fuelFlag = this.$fuelFlag % 60;
        if (this.self.speed < 0.8 * this.self.maxSpeed)
            {
            this.$fuelCounter += 1;      // cruise mode
            }
        else
            {
            this.$fuelCounter += 2;      // high speed mode
            }
		}
        
	if(player.alertCondition != 1)
		{ 
		this.$fuelCounter += 1;      // additional fuel consumption in mass lock state
		}
        
	if(this.self.energy < this.self.maxEnergy)
		{ 
		this.$fuelCounter += this.self.energyRechargeRate;      // additional fuel consumption to recharge energy stock
		}        

	if(this.$fuelCounter >= 360)
		{ 
		this.self.fuel -= 0.1;    // fuel decrement
        this.$fuelCounter -= 360;    //reset fuel counter
		}

	if(this.self.fuel == 0.1)     // warning message - fuel low
		{
		player.consoleMessage("FUEL LOW!", 3);
		}

	if(this.self.fuel == 0)       // fuel empty - shields switch to auxiliary battery
		{
		this.self.aftShield = 0;
		this.self.forwardShield = 0;
		this.self.energy += (this.self.aftShieldRechargeRate + this.self.forwardShieldRechargeRate);    // to compensate energy drain for shield recharging
        this.$energyCounter -= 0.1;  // auxiliary battery discharge rate
		if(this.self.energy > this.$energyCounter)
			{
			this.self.energy = this.$energyCounter;
			}
		if(this.self.energy <= 0)
            {
            this.self.explode();
            }
		}
	
	if(this.self.torusEngaged == true) // if the ship is under Torus drive
		{
		if(this.self.aftShield > 0.25 * this.self.maxAftShield)
            {
            this.self.aftShield = 0.25 * this.self.maxAftShield;         // Aft shield level decreased
            }
		if(this.self.forwardShield > 0.25 * this.self.maxForwardShield)
            {
            this.self.forwardShield = 0.25 * this.self.maxForwardShield;     // Forward shield level decreased
            }
		this.self.energy += (this.self.aftShieldRechargeRate + this.self.forwardShieldRechargeRate);    // to compensate energy drain for shield recharging
        this.$fuelCounter += 4;      // additional fuel consumption in Torus drive mode
        if(this.self.fuel == 0)
            {
            this.self.energy -= 10;
            }
		if(this.self.energy <= 0)
            {
            this.self.explode();
            }
        }
	else
		{ return; }                 // if not under Torus drive, exit function
		
	}