"use strict";
this.name				= "SolarWind";
this.author				= "Stranger";
this.copyright			= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description		= "This script simulates collection of fuel from solar wind in sun proximity";
this.version			= "2.5";

this.startUp = this.playerBoughtNewShip = function()
    {
    this.self = player.ship;
    }

this.shipWillLaunchFromStation = this.$startCollectFuelTimer = function()
	{
	this.$fuelCollectFlag = 0;
    this.$fuelCollectCounter = 0;
    this.$endurance = this.self.serviceLevel/100;
    this.$wear = 1 - this.$endurance;
	if(this.$fuelCollectWatchTimer)
		{ this.$fuelCollectWatchTimer.start(); }
	else
		{ this.$fuelCollectWatchTimer = new Timer(this, this.$checkCollectFuel,0,1); }
	}

this.shipWillDockWithStation = this.shipDied = this.$stopCollectFuelTimer = function()
	{
	this.$fuelCollectFlag = 0;
    this.$fuelCollectCounter = 0;
    this.self.scoopOverride = false; // to avoid the 'scoop active' message being played while docked on Rock Hermits
    log(this.name, "Docking: solar wind scooping stops");
	if(this.$fuelCollectWatchTimer && this.$fuelCollectWatchTimer.isRunning)
        {
        log(this.name, "stopping fuelCollectWatchTimer...");
        this.$fuelCollectWatchTimer.stop();        
        } 
	}
	
this.$checkCollectFuel = function()
	{
    if (player.alertCondition != 1 && this.self.scoopOverride == true)
        {
        this.self.scoopOverride = false;
        }
    if (system.isInterstellarSpace || player.alertCondition != 1 || !this.self.position) return;
    var w = worldScripts.AstroLibrary;
    var sunDistance = this.self.position.distanceTo(system.sun).toFixed(0);
    var solarWind = w.$astroLib_SolarWind(sunDistance);
	if(this.self.speed < 1.1 * this.self.maxSpeed && solarWind > 0.1 && this.self.equipmentStatus( "EQ_FUEL_SCOOPS" ) == "EQUIPMENT_OK")       // ship in cruise mode AND sun proximity AND functional Fuel Scoop installed
		{
        this.$fuelCollectFlag += 1;                           //  increment flag, looping between 0 and 60
		this.$fuelCollectFlag = this.$fuelCollectFlag % 60;
        this.$fuelCollectCounter += solarWind * (1 - 2 * this.$wear * this.$wear);
        if(this.self.scoopOverride == false)
            {
            this.self.scoopOverride = true;
            }
		}
    else
        {
        if(this.self.scoopOverride == true)
            {
            this.self.scoopOverride = false;
            }
        }

	if(this.$fuelCollectCounter >= 6)
		{ 
        this.self.fuel += 0.1;        // fuel increment
        this.$fuelCollectCounter -= 6;   // reset fuel collector counter
		}        

	if(this.$fuelCollectCounter >= 12)
		{ 
		solarWind = 0;         // shut off collector on overload
        this.$fuelCollectCounter = 0;    // reset fuel collector counter
		} 

	}